Debian Bug report logs - #694403
Please ship an init script, not just a systemd unit

version graph

Package: bootchart2; Maintainer for bootchart2 is David Paleino <dapal@debian.org>; Source for bootchart2 is src:bootchart2.

Reported by: Steve Langasek <vorlon@debian.org>

Date: Mon, 26 Nov 2012 06:45:01 UTC

Severity: serious

Found in version bootchart2/0.14.4-1.1

Fixed in version bootchart2/0.14.4-2

Done: David Paleino <dapal@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Mon, 26 Nov 2012 06:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
New Bug report received and forwarded. Copy sent to David Paleino <dapal@debian.org>. (Mon, 26 Nov 2012 06:45:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: submit@bugs.debian.org
Subject: Please ship an init script, not just a systemd unit
Date: Sun, 25 Nov 2012 22:42:54 -0800
[Message part 1 (text/plain, inline)]
Package: bootchart2
Version: 0.14.4-1.1
Severity: serious
Justification: Policy 9.11

The bootchart2 package currently ships systemd unit files, but no init
script.  This means the behavior is different when booting with systemd than
when booting with sysvinit.  This appears to be a violation of Policy 9.11:

  [A]ny package integrating with other init systems must also be
  backwards-compatible with `sysvinit' by providing a SysV-style init
  script with the same name as and equivalent functionality to any
  init-specific job, as this is the only start-up configuration method
  guaranteed to be supported by all init implementations.

In practice, my experience is that if I install bootchart, then install
bootchart2 without purging bootchart, and boot with systemd, systemd gets
very confused and leaves the bootchart daemon running indefinitely.  In
contrast, if I boot with sysvinit, the init script in /etc/rc2.d/ does a
perfectly adequate job of stopping bootchartd at the right point.  So the
lack of sysvinit integration looks to actually hurt integration with systemd
too.

BTW, Ubuntu uses an initramfs hook instead of a boot argument as the means
of starting bootchart (for bootchart 1).  Have you considered including such
a method in the package?  It seems obvious to me that we would want
bootcharting of the initramfs to be included by default.  I'm happy to work
out a patch for this if that would be of use.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Mon, 26 Nov 2012 16:42:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to dapal@debian.org:
Extra info received and forwarded to list. Copy sent to David Paleino <dapal@debian.org>. (Mon, 26 Nov 2012 16:42:06 GMT) Full text and rfc822 format available.

Message #10 received at 694403@bugs.debian.org (full text, mbox):

From: David Paleino <dapal@debian.org>
To: Steve Langasek <vorlon@debian.org>, 694403@bugs.debian.org
Subject: Re: Bug#694403: Please ship an init script, not just a systemd unit
Date: Mon, 26 Nov 2012 17:39:33 +0100
[Message part 1 (text/plain, inline)]
tags 694403 confirmed pending
thanks

Hello Steve,

On Sun, 25 Nov 2012 22:42:54 -0800, Steve Langasek wrote:

> [..]
>
> In practice, my experience is that if I install bootchart, then install
> bootchart2 without purging bootchart, and boot with systemd, systemd gets
> very confused and leaves the bootchart daemon running indefinitely.  In
> contrast, if I boot with sysvinit, the init script in /etc/rc2.d/ does a
> perfectly adequate job of stopping bootchartd at the right point.  So the
> lack of sysvinit integration looks to actually hurt integration with systemd
> too.

Could you please test the attached initscript? Or, alternatively, do you want a
compiled package to test?
I wrote it basing on /etc/init.d/skeleton, and on what bootchartd is expected
to do (i.e. when you do "/etc/init.d/bootchart2 start", it actually *stops* the
daemon).

I'm not a systemd user, so I would be glad if you could test this for me,
before doing an upload to sid :)

Kindly,
David

-- 
 . ''`.   Debian developer | http://wiki.debian.org/DavidPaleino
 : :'  : Linuxer #334216 --|-- http://www.hanskalabs.net/
 `. `'`  GPG: 1392B174 ----|---- http://deb.li/dapal
   `-   2BAB C625 4E66 E7B8 450A C3E1 E6AA 9017 1392 B174
[bootchart2.init (application/octet-stream, attachment)]
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Mon, 26 Nov 2012 17:36:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Biebl <biebl@debian.org>:
Extra info received and forwarded to list. Copy sent to David Paleino <dapal@debian.org>. (Mon, 26 Nov 2012 17:36:05 GMT) Full text and rfc822 format available.

Message #15 received at 694403@bugs.debian.org (full text, mbox):

From: Michael Biebl <biebl@debian.org>
To: 694403@bugs.debian.org, Steve Langasek <vorlon@debian.org>
Cc: Tollef Fog Heen <tfheen@err.no>
Subject: Please ship an init script, not just a systemd unit
Date: Mon, 26 Nov 2012 18:34:27 +0100
[Message part 1 (text/plain, inline)]
Hi,

> In practice, my experience is that if I install bootchart, then install
> bootchart2 without purging bootchart, and boot with systemd, systemd gets
> very confused and leaves the bootchart daemon running indefinitely.  In
> contrast, if I boot with sysvinit, the init script in /etc/rc2.d/ does a
> perfectly adequate job of stopping bootchartd at the right point.  So the
> lack of sysvinit integration looks to actually hurt integration with systemd
> too.

systemd doesn't get "very confused". The bug here is, that bootchart2
ships systemd unit files, but doesn't actually enable them.
The systemd unit responsible for stopping the bootchart daemon is called
bootchart-done.service.
Until we ship the necessary helper tool, systemd units need to be
enabled manually via systemctl enable <foo.service>

David, as for this particular case, when you ship a sysv init script,
please consider naming it after the native systemd service file (i.e
bootchart-done).

Cheers,
Michael

-- 
Why is it that all of the instruments seeking intelligent life in the
universe are pointed away from Earth?

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Mon, 26 Nov 2012 18:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to dapal@debian.org:
Extra info received and forwarded to list. Copy sent to David Paleino <dapal@debian.org>. (Mon, 26 Nov 2012 18:12:03 GMT) Full text and rfc822 format available.

Message #20 received at 694403@bugs.debian.org (full text, mbox):

From: David Paleino <dapal@debian.org>
To: 694403@bugs.debian.org
Cc: Michael Biebl <biebl@debian.org>, Steve Langasek <vorlon@debian.org>, Tollef Fog Heen <tfheen@err.no>
Subject: Re: Bug#694403: Please ship an init script, not just a systemd unit
Date: Mon, 26 Nov 2012 19:10:08 +0100
[Message part 1 (text/plain, inline)]
On Mon, 26 Nov 2012 18:34:27 +0100, Michael Biebl wrote:

> Hi,
> 
> > In practice, my experience is that if I install bootchart, then install
> > bootchart2 without purging bootchart, and boot with systemd, systemd gets
> > very confused and leaves the bootchart daemon running indefinitely.  In
> > contrast, if I boot with sysvinit, the init script in /etc/rc2.d/ does a
> > perfectly adequate job of stopping bootchartd at the right point.  So the
> > lack of sysvinit integration looks to actually hurt integration with systemd
> > too.
> 
> systemd doesn't get "very confused". The bug here is, that bootchart2
> ships systemd unit files, but doesn't actually enable them.
> The systemd unit responsible for stopping the bootchart daemon is called
> bootchart-done.service.
> Until we ship the necessary helper tool, systemd units need to be
> enabled manually via systemctl enable <foo.service>

Am I supposed to run that in postinst/prerm (disable)? Or should I just
document it in README.Debian? Or is it common knowledge among systemd users?

> David, as for this particular case, when you ship a sysv init script,
> please consider naming it after the native systemd service file (i.e
> bootchart-done).

ACK.

Thanks,
David

-- 
 . ''`.   Debian developer | http://wiki.debian.org/DavidPaleino
 : :'  : Linuxer #334216 --|-- http://www.hanskalabs.net/
 `. `'`  GPG: 1392B174 ----|---- http://deb.li/dapal
   `-   2BAB C625 4E66 E7B8 450A C3E1 E6AA 9017 1392 B174
[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Mon, 26 Nov 2012 23:45:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Biebl <biebl@debian.org>:
Extra info received and forwarded to list. Copy sent to David Paleino <dapal@debian.org>. (Mon, 26 Nov 2012 23:45:10 GMT) Full text and rfc822 format available.

Message #25 received at 694403@bugs.debian.org (full text, mbox):

From: Michael Biebl <biebl@debian.org>
To: dapal@debian.org
Cc: 694403@bugs.debian.org, Steve Langasek <vorlon@debian.org>, Tollef Fog Heen <tfheen@err.no>
Subject: Re: Bug#694403: Please ship an init script, not just a systemd unit
Date: Tue, 27 Nov 2012 00:41:21 +0100
[Message part 1 (text/plain, inline)]
On 26.11.2012 19:10, David Paleino wrote:
> On Mon, 26 Nov 2012 18:34:27 +0100, Michael Biebl wrote:

>> Until we ship the necessary helper tool, systemd units need to be
>> enabled manually via systemctl enable <foo.service>
> 
> Am I supposed to run that in postinst/prerm (disable)? Or should I just
> document it in README.Debian? Or is it common knowledge among systemd users?

For the time being, I wouldn't advise adding those calls manually to the
maintainer scripts. Since systemctl is not guaranteed to be around, you
would either have to add a hard dependency on systemd or make the
systemctl calls conditional. Neither of those options is ideal.

Adding this to README.Debian certainly doesn't hurt.
Once we have the necessary support in debhelper etc. (which should land
as in jessie), you can drop that note again.

>> David, as for this particular case, when you ship a sysv init script,
>> please consider naming it after the native systemd service file (i.e
>> bootchart-done).

Thanks.

Btw, having initramfs integration as Steve pointed out, would be really
nice.
On my system loading the kernel and the initramfs already takes longer
then booting the userspace. So having a chart of the initramfs would be
really helpful.

Cheers,
Michael


-- 
Why is it that all of the instruments seeking intelligent life in the
universe are pointed away from Earth?

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Tue, 27 Nov 2012 09:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Riccardo Magliocchetti <riccardo.magliocchetti@gmail.com>:
Extra info received and forwarded to list. Copy sent to David Paleino <dapal@debian.org>. (Tue, 27 Nov 2012 09:51:03 GMT) Full text and rfc822 format available.

Message #30 received at 694403@bugs.debian.org (full text, mbox):

From: Riccardo Magliocchetti <riccardo.magliocchetti@gmail.com>
To: Michael Biebl <biebl@debian.org>, 694403@bugs.debian.org, dapal@debian.org
Cc: Steve Langasek <vorlon@debian.org>, Tollef Fog Heen <tfheen@err.no>
Subject: Re: Bug#694403: Please ship an init script, not just a systemd unit
Date: Tue, 27 Nov 2012 10:48:33 +0100
Il 27/11/2012 00:41, Michael Biebl ha scritto:
>
> Btw, having initramfs integration as Steve pointed out, would be really
> nice.
> On my system loading the kernel and the initramfs already takes longer
> then booting the userspace. So having a chart of the initramfs would be
> really helpful.

Last year i've added a bootchart2 initramfs hook here
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=603656#15

Also see comment #16 for a correction in the instructions.

Should we ship this stuff in the package or should them added to 
initramfs-tools ?

thanks,
riccardo



Information forwarded to debian-bugs-dist@lists.debian.org, David Paleino <dapal@debian.org>:
Bug#694403; Package bootchart2. (Tue, 27 Nov 2012 10:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Riccardo Magliocchetti <riccardo.magliocchetti@gmail.com>:
Extra info received and forwarded to list. Copy sent to David Paleino <dapal@debian.org>. (Tue, 27 Nov 2012 10:27:05 GMT) Full text and rfc822 format available.

Message #35 received at 694403@bugs.debian.org (full text, mbox):

From: Riccardo Magliocchetti <riccardo.magliocchetti@gmail.com>
To: Steve Langasek <vorlon@debian.org>, 694403@bugs.debian.org
Cc: Michael Biebl <biebl@debian.org>, dapal@debian.org
Subject: Re: Bug#694403: Please ship an init script, not just a systemd unit
Date: Tue, 27 Nov 2012 11:25:27 +0100
Hello,

I'm one of the upstream maintainers of bootchart2.

Il 26/11/2012 07:42, Steve Langasek ha scritto:
> Package: bootchart2
> Version: 0.14.4-1.1
> Severity: serious
> Justification: Policy 9.11
>
> The bootchart2 package currently ships systemd unit files, but no init
> script.  This means the behavior is different when booting with systemd than
> when booting with sysvinit.  This appears to be a violation of Policy 9.11:
>
>    [A]ny package integrating with other init systems must also be
>    backwards-compatible with `sysvinit' by providing a SysV-style init
>    script with the same name as and equivalent functionality to any
>    init-specific job, as this is the only start-up configuration method
>    guaranteed to be supported by all init implementations.

Ouch, from what i understand from systemd they are supposed to stop 
/sbin/bootchartd after 20 seconds of active state. Do we have that kind 
of control with sysvinit? other than calling sleep :)

> In practice, my experience is that if I install bootchart, then install
> bootchart2 without purging bootchart, and boot with systemd, systemd gets
> very confused and leaves the bootchart daemon running indefinitely.  In
> contrast, if I boot with sysvinit, the init script in /etc/rc2.d/ does a
> perfectly adequate job of stopping bootchartd at the right point.  So the
> lack of sysvinit integration looks to actually hurt integration with systemd
> too.

Well, i don't what the original bootchart init script is doing but 
bootchart2 on sysvinit is not supposed to require it thus we do not ship 
it :). /sbin/bootchartd should stop itself when a process set in 
EXIT_PROC from /etc/bootchartd.conf is found. Of course you can call 
/sbin/bootchard stop manually.

So imho an init script is not that useful, even more if a start action 
will actually stop the collector.

Maybe we should conflict with bootchart because one of its script is 
affecting us though.

Said that your feedback is much appreciated, I'd really like to have 
bootchart2 be the first choice when doing boot profiling instead of the 
old bootchart.

thanks,
riccardo




Reply sent to David Paleino <dapal@debian.org>:
You have taken responsibility. (Sat, 08 Dec 2012 18:51:10 GMT) Full text and rfc822 format available.

Notification sent to Steve Langasek <vorlon@debian.org>:
Bug acknowledged by developer. (Sat, 08 Dec 2012 18:51:10 GMT) Full text and rfc822 format available.

Message #40 received at 694403-close@bugs.debian.org (full text, mbox):

From: David Paleino <dapal@debian.org>
To: 694403-close@bugs.debian.org
Subject: Bug#694403: fixed in bootchart2 0.14.4-2
Date: Sat, 08 Dec 2012 18:47:29 +0000
Source: bootchart2
Source-Version: 0.14.4-2

We believe that the bug you reported is fixed in the latest version of
bootchart2, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 694403@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
David Paleino <dapal@debian.org> (supplier of updated bootchart2 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 08 Dec 2012 19:35:08 +0100
Source: bootchart2
Binary: bootchart2 pybootchartgui
Architecture: source i386 all
Version: 0.14.4-2
Distribution: unstable
Urgency: low
Maintainer: David Paleino <dapal@debian.org>
Changed-By: David Paleino <dapal@debian.org>
Description: 
 bootchart2 - boot process performance analyser
 pybootchartgui - viewer for boot process performance analysis results
Closes: 694403
Changes: 
 bootchart2 (0.14.4-2) unstable; urgency=low
 .
   * Acknowledge NMU.
   * Provide also an initscript (Closes: #694403)
Checksums-Sha1: 
 01ff1e1ed6c861481aed8a142f5459f495690c6e 1366 bootchart2_0.14.4-2.dsc
 25f4140c004c4ca90fe05f2b948c6bffeede30c6 7013 bootchart2_0.14.4-2.debian.tar.gz
 38795c4f1d6af027d758ead2e8b9e82003218667 32026 bootchart2_0.14.4-2_i386.deb
 91acf98581809da0780566aa711f0fd5d5da3d26 32904 pybootchartgui_0.14.4-2_all.deb
Checksums-Sha256: 
 859fcd49143b802c3f30fee4214c52ecf021182ea3d7ae6301717a102e42c951 1366 bootchart2_0.14.4-2.dsc
 9f111ced2cc29217dd7f101e46c639b5abf14a8584de0ffac0b984bcb008fe20 7013 bootchart2_0.14.4-2.debian.tar.gz
 91a7504dbf6cb165b3e8df1440107202360ef542be8a245d0c5694fae32d9aec 32026 bootchart2_0.14.4-2_i386.deb
 d5f46a64933bacc4639baf39061c5ac044d37c4e45bb51abbc66666fb6e8d7f4 32904 pybootchartgui_0.14.4-2_all.deb
Files: 
 9f01cc1e9e4dd414a03d9627ea75ce07 1366 utils optional bootchart2_0.14.4-2.dsc
 d9194cf40ffb7c49ea1dd90cf5a593fa 7013 utils optional bootchart2_0.14.4-2.debian.tar.gz
 f8d42f1449f628d8ba7cfa0b8e63b7d0 32026 utils optional bootchart2_0.14.4-2_i386.deb
 e02746051766eb3ac141cd44d1b2f594 32904 utils optional pybootchartgui_0.14.4-2_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlDDigAACgkQ5qqQFxOSsXQFlACglGsMaY36ZXrPJrgAUzoCkE6y
pUkAoLT8L3c4gzIu1MmP1fGhSFolxxKs
=X6GN
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 08 Jan 2013 07:25:46 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 01:02:13 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.